/* ------------------------------------------------------------------------ */
/*                                                                          */
/*  Copyright (C)                                                           */
/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 2 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful, but     */
/*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-    */
/*  ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General        */
/*  Public License for more details.                                        */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   */
/*                                                                          */
/* ------------------------------------------------------------------------ */
/*  $Author: vogje02 $ $Revision: 1.2 $ $Date: 2002/07/09 10:55:30 $      */
/* ------------------------------------------------------------------------ */

#if !defined(AFX_DISCOVERPAGE_H__0D7C5C9E_A4FF_4610_BDF3_FD89FC33FD55__INCLUDED_)
#define AFX_DISCOVERPAGE_H__0D7C5C9E_A4FF_4610_BDF3_FD89FC33FD55__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include "nmapwin.h"
#include "options.h"

/**
 * Discover page of the options folder
 */
class CDiscoverPage : public CPropertyPage
{
public:
	/**
	 * Construction
	 */
	CDiscoverPage(CWnd* pParent = NULL);   // standard constructor

    // Dialog Data
	//{{AFX_DATA(CDiscoverPage)
	enum { IDD = IDD_DIALOG_DISCOVER };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	/**
	 * Set status bar for error/info messages
	 */
	void SetStatusBar( CEdit* status );

	/**
	 * Called when the folder page becomes visible. This is
	 * putting the page into the right place.
	 */
	void SetVisible(CTabCtrl* parent);

	/**
	 * Update the widgets according to new options settings.
	 */
	void SetOptions();

    // Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDiscoverPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:

	// Generated message map functions
	//{{AFX_MSG(CDiscoverPage)
	afx_msg void OnRadio6();
	afx_msg void OnRadio7();
	afx_msg void OnRadio8();
	afx_msg void OnRadio9();
	afx_msg UINT OnGetDlgCode( );
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	/**
	 * Puts the new values into the options struct.
	 */
	void BuildCommand();

	/**
	 * Initialization
	 */
	bool init;

	/**
	 * Status bar for error/info messages
	 */
	CEdit* m_statusbar;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DISCOVERPAGE_H__0D7C5C9E_A4FF_4610_BDF3_FD89FC33FD55__INCLUDED_)
