/* ------------------------------------------------------------------------ */
/*                                                                          */
/*  Copyright (C)                                                           */
/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 2 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful, but     */
/*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-    */
/*  ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General        */
/*  Public License for more details.                                        */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   */
/*                                                                          */
/* ------------------------------------------------------------------------ */
/*  $Author: vogje02 $ $Revision: 1.6 $ $Date: 2002/07/28 17:13:20 $      */
/* ------------------------------------------------------------------------ */

//{{AFX_INCLUDES()
#include "statusbar.h"
#include "listener.h"
//}}AFX_INCLUDES

#if !defined(AFX_NMAPWINDLG_H__152084D8_A041_4221_B1D4_78C846215196__INCLUDED_)
#define AFX_NMAPWINDLG_H__152084D8_A041_4221_B1D4_78C846215196__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <htmlhelp.h> 
#include "nmapwin.h"
#include "scanpage.h"
#include "discoverpage.h"
#include "optionspage.h"
#include "timingpage.h"
#include "filespage.h"
#include "servicepage.h"
#include "windowspage.h"
#include "options.h"

#define version "1.3.0"

/////////////////////////////////////////////////////////////////////////////
// CNmapwinDlg dialog

class CNmapwinDlg : public CDialog
{
// Construction
public:
	CNmapwinDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CNmapwinDlg)
	enum { IDD = IDD_NMAPWIN_DIALOG };
	CTabCtrl m_optionstab;
	CEdit	 m_outputedit;
	CStatic	 m_freeicon;
	CStatic	 m_busyicon;
	CEdit	 m_invis;
	CEdit	 m_date;
	CEdit	 m_statusbar;
	CEdit	 m_time;
	CEdit    m_loglist;
	CEdit	 m_hostedit;
	CButton	 m_stop;
	CButton	 m_start;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNmapwinDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CNmapwinDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg void OnScan();
	afx_msg void OnStop();
	afx_msg void OnChangeEdit1();
	afx_msg void OnUpdateEdit1();
	afx_msg void OnChangeEdit7();
	virtual void OnCancel();
	afx_msg void OnUpdateEdit8();
	afx_msg void OnButton1();
	afx_msg void OnCheck6();
	afx_msg void OnChangeEdit5();
	afx_msg void OnCheck9();
	afx_msg void OnChangeEdit9();
	afx_msg void OnButton3();
	afx_msg void OnButton4();
	afx_msg void OnSelchangeTab1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	char *BuildCommand();
	HANDLE  ExecuteWin(char *command);
	
private:

	HANDLE pipes[2]; // 0 == read; 1 == write
	HANDLE NmapHandle;
	PROCESS_INFORMATION Nmap_Proc;
	STARTUPINFO Nmap_Start;
	int nmap_pid;
	CListener* listener;

	// Options pages
	CScanPage m_scanPage;
	CDiscoverPage m_discoverPage;
	COptionsPage m_optionsPage;
	CTimingPage m_timingPage;
	CFilesPage m_filesPage;
	CServicePage m_servicePage;
	CWindowsPage m_windowsPage;

	void UpdateStatusBar( char* text );
	void SetBusy( bool busy );
	bool CheckCommand();

	// Add a CBrush* to store the new background brush for edit controls.
    CBrush* m_pEditBkBrush;


	HICON freeicon;
	HICON busyicon;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NMAPWINDLG_H__152084D8_A041_4221_B1D4_78C846215196__INCLUDED_)
