/* ------------------------------------------------------------------------ */
/*                                                                          */
/*  Copyright (C)                                                           */
/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 2 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful, but     */
/*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-    */
/*  ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General        */
/*  Public License for more details.                                        */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   */
/*                                                                          */
/* ------------------------------------------------------------------------ */
/*  $Author: vogje02 $ $Revision: 1.7 $ $Date: 2002/07/28 17:13:20 $      */
/* ------------------------------------------------------------------------ */

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdio.h"
#include "string.h"
#include "winsock.h"

#define MODE_CONNECT		 0
#define MODE_SYN_STEALTH	 1
#define MODE_FIN_STEALTH	 2
#define MODE_PING_SWEEP 	 3 
#define MODE_UDP_SCAN		 4
#define MODE_NULL_SCAN		 5
#define MODE_XMAS_TREE		 6
#define MODE_IP_SCAN		 7
#define MODE_ACK_TREE		 8
#define MODE_WIN_SCAN		 9
#define MODE_RPC_SCAN		10
#define MODE_LIST_SCAN		11

#define DISC_TCP	         0
#define DISC_TCP_ICMP        1
#define DISC_ICMP	         2
#define DISC_NONE	         3

#define THROTTLE_PARANOID	 0
#define THROTTLE_SNEAKY		 1
#define THROTTLE_POLITE		 2
#define THROTTLE_NORMAL		 3
#define THROTTLE_AGGRESIVE	 4
#define THROTTLE_INSANE		 5

#define OUTFILE_NORMAL		 0
#define OUTFILE_XML			 1
#define OUTFILE_GREP		 2
#define OUTFILE_ALL			 3

class COptions
{
public:
	COptions();

	// Builds the nmap command options from the 
	// options struct.
	char* GetCommand( char* cmd );

	// Host field
	char hostName[256];
	
	// Scan mode
	int scanMode;

	// Port range
	bool portRangeB;
	char portRangeS[80];

	// Send device
	bool deviceB;
	char deviceS[80];

	// Send device
	bool sAddressB;
	char sAddressS[80];

	// Decoy
	bool decoyB;
	char decoyS[80];

	// Decoy
	bool bounceB;
	char bounceS[80];

	// Port
	bool portB;
	char portS[80];

	// Discovery
	int discMode;

	// Fragmentation
	bool fragB;

	// Ident
	bool identB;

	// Resolve all
	bool resolveAllB;

	// Do not resolve
	bool resolveNotB;

	// Fast scan
	bool fastScanB;

	// OSDetection
	bool osDetectionB;

	// Random host
	bool randomHostB;

	// Resume scan
	bool resumeB;

    // Debug
	bool debugB;

	// Verbose
	bool verboseB;

	// Verbose
	bool veryVerboseB;

	// Throttle
	char throttle[10];

	// Host timeout
	bool hostTimeoutB;
	char hostTimeout[10];

	// Min RTT
	bool minRttB;
	char minRtt[10];

	// Max RTT
	bool maxRttB;
	char maxRtt[10];

	// Initial RTT
	bool initialRttB;
	char initialRtt[10];

	// Parallelism
	bool parallelB;
	char parallel[10];

	// Delay
	bool delayB;
	char delay[10];

	// Input file
	bool infileB;
	char infile[256];

	// Output file
	bool outfileB;
	char outfile[256];
	int outfileType;
	bool outfileAppend;

	// List Windows interfaces
	bool winInterfaceB;

	// No Pcap library
	bool winNoPcapB;

	// No HLP Api
	bool winNoHlpApiB;

	// No raw socket support
	bool winNoRawSocketB;

	// Force raw socket
	bool winForceRawSocketB;

	// NT4 routing
	bool winNt4RouteB;

	// Win Trace
	bool winTraceB;

	// Win service
	bool autoStart;

private: 
};
